# Base git commit: 98f7e32f20d2
# (Linux 6.11)
# 
# Author:    Russell King (Fri 14 Feb 13:32:36 GMT 2020)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:41:35 BST 2024)
# 
#   net: dsa: debugging prints
# 
#   Signed-off-by: Russell King
# 
#   20908720b29757796501935e7088fe34ee24015b
#    drivers/net/dsa/mv88e6xxx/port.c | 12 ++++++++++++
#    1 file changed, 12 insertions(+)
# 
# Author:    Russell King (Thu  6 Feb 18:11:03 GMT 2020)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:41:34 BST 2024)
# 
#   ARM: dts: vf610-zii-dev-rev-c: fix 88x3310 reset
# 
#   Hogged GPIOs no longer work, switch to using a bus-level reset
#   instead.
# 
#   Signed-off-by: Russell King
# 
#   536efe7f60fc01e34563a112ebc17dc3bee4b3c0
#    arch/arm/boot/dts/nxp/vf/vf610-zii-dev-rev-c.dts | 10 +++-------
#    1 file changed, 3 insertions(+), 7 deletions(-)
# 
# Author:    Russell King (Fri  8 Dec 10:08:41 GMT 2017)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:41:34 BST 2024)
# 
#   ARM: dts: vf610-zii-dev-rev-c: add support for SFF modules
# 
#   Signed-off-by: Russell King
# 
#   1e956cd03d5221196191f3d4654b2534bee2c757
#    arch/arm/boot/dts/nxp/vf/vf610-zii-dev-rev-c.dts | 2 +-
#    drivers/net/phy/Kconfig                          | 2 +-
#    2 files changed, 2 insertions(+), 2 deletions(-)
# 
# Author:    Russell King (Fri  8 Dec 10:08:41 GMT 2017)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:41:33 BST 2024)
# 
#   ARM: dts: vf610-zii-dev-rev-c: add support for 88x3310 10Gbit PHY
# 
#   Add support for the 88x3310 10Gbit PHY on the ZII rev C board.
# 
#   Signed-off-by: Russell King
# 
#   78c183d0cee53076ddcbe614fad8fb1bdff1bcfd
#    arch/arm/boot/dts/nxp/vf/vf610-zii-dev-rev-c.dts | 23 +++++++++++++++++++++++
#    1 file changed, 23 insertions(+)
# 
# Author:    Russell King (Fri 21 Feb 12:46:58 GMT 2020)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:41:33 BST 2024)
# 
#   ARM: dts: vf610-zii-dev-rev-b: remove lan8
# 
#   lan8 is mis-wired, so it can only transmit packets but not receive.
#   Remove the non-functional lan8 from the dts file.
# 
#   Signed-off-by: Russell King
# 
#   6e0101a5d1702d93b2333f11b94355dd36763fc6
#    arch/arm/boot/dts/nxp/vf/vf610-zii-dev-rev-b.dts | 6 +-----
#    1 file changed, 1 insertion(+), 5 deletions(-)
# 
# Author:    Russell King (Wed 20 Dec 22:26:48 GMT 2017)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:41:32 BST 2024)
# 
#   ARM: dts: vf610-zii-dev-rev-b: add optical p2 SFF description
# 
#   Add a description for the optical p2 port on the 88e6352.
# 
#   Note: to use this, R412 must not be fitted.
# 
#   Signed-off-by: Russell King
# 
#   a4a7221aebc2bc89506c2a364bee0752398c8bbb
#    arch/arm/boot/dts/nxp/vf/vf610-zii-dev-rev-b.dts | 6 ++++++
#    1 file changed, 6 insertions(+)
# 
# Author:    Russell King (Tue 19 Dec 11:12:15 GMT 2017)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:41:32 BST 2024)
# 
#   ARM: dts: vf610-zii-dev-rev-b: add support for SFF modules
# 
#   Signed-off-by: Russell King
# 
#   38bc8d8f43a8942a250050726bcf0cda2722474b
#    arch/arm/boot/dts/nxp/vf/vf610-zii-dev-rev-b.dts | 69 +++++++++++-------------
#    1 file changed, 31 insertions(+), 38 deletions(-)
# 
# Author:    Russell King (Tue 19 Dec 11:27:31 GMT 2017)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:41:31 BST 2024)
# 
#   ARM: dts: vf610-zii-dev-rev-b: add interrupts for 88e1545 PHY
# 
#   The 88e1545 PHY has its interrupts wired to the VF610, so we might as
#   well use them.
# 
#   Signed-off-by: Russell King
#   ---
#   This is certainly not correct, as all PHYs on this device share the
#   same interrupt line, but we can't specify the pinmux settings
#   individually on each PHY.  How should this be handled?
# 
#   1e8c29c764d66dfb0fa48a62a6558991e5b24531
#    arch/arm/boot/dts/nxp/vf/vf610-zii-dev-rev-b.dts | 14 ++++++++++++++
#    1 file changed, 14 insertions(+)
# 
# Author:    Russell King (Fri 15 Dec 16:13:06 GMT 2017)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:41:31 BST 2024)
# 
#   net: dsa: allow init to continue when no phy
# 
#   Signed-off-by: Russell King
# 
#   993625d7fb18a426f2c64b9824eeaede24c0e3f5
#    net/dsa/user.c | 3 ++-
#    1 file changed, 2 insertions(+), 1 deletion(-)
# 
# Author:    Russell King (Oracle) (Thu 17 Aug 21:56:27 BST 2023)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:37 BST 2024)
# 
#   net: dsa: mv88e6xxx: add 6352 family EEE support
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   95df51f9752bdca961c1354ad25034f6b4f8b31e
#    drivers/net/dsa/mv88e6xxx/chip.c | 8 ++++++++
#    1 file changed, 8 insertions(+)
# 
# Author:    Russell King (Oracle) (Sat  4 Dec 20:13:11 GMT 2021)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:37 BST 2024)
# 
#   net: phy: generate PHY mdio modalias
# 
#   The modalias string provided in the uevent sysfs file does not conform
#   to the format used in PHY driver modules. One of the reasons is that
#   udev loading of PHY driver modules has not been an expected use case.
# 
#   This patch changes the MODALIAS entry for only PHY devices from:
#           MODALIAS=of:Nethernet-phyT(null)
#   to:
#           MODALIAS=mdio:00000000001000100001010100010011
# 
#   Other MDIO devices (such as DSA) remain as before.
# 
#   However, having udev automatically load the module has the advantage
#   of making use of existing functionality to have the module loaded
#   before the device is bound to the driver, thus taking advantage of
#   multithreaded boot systems, potentially decreasing the boot time.
# 
#   However, this patch will not solve any issues with the driver module
#   not being loaded prior to the network device needing to use the PHY.
#   This is something that is completely out of control of any patch to
#   change the uevent mechanism.
# 
#   Reported-by: Yinbo Zhu
#   Signed-off-by: Russell King (Oracle)
# 
#   f5d49a8d7c9aa62d6232a479541b21bbe96a72f8
#    drivers/net/phy/mdio_bus.c   |  8 ++++++++
#    drivers/net/phy/phy_device.c | 14 ++++++++++++++
#    include/linux/mdio.h         |  2 ++
#    3 files changed, 24 insertions(+)
# 
# Author:    Russell King (Oracle) (Sat 27 Nov 16:05:36 GMT 2021)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:37 BST 2024)
# 
#   net: use phylink_mode_*() helpers
# 
#   Use the phylink_mode_*() helpers in all drivers so we can change the
#   definition of the "mode" argument.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   64ef1e85aa74ac3024a5083411aa9e41968de1aa
#    drivers/net/dsa/b53/b53_common.c         |  7 ++++---
#    drivers/net/dsa/bcm_sf2.c                |  2 +-
#    drivers/net/dsa/mv88e6xxx/chip.c         | 13 +++++++------
#    drivers/net/dsa/mv88e6xxx/port.c         |  2 +-
#    drivers/net/ethernet/cadence/macb_main.c |  2 +-
#    drivers/net/phy/phylink.c                | 29 +++++++++++++++--------------
#    6 files changed, 29 insertions(+), 26 deletions(-)
# 
# Author:    Russell King (Oracle) (Sat 27 Nov 14:15:19 GMT 2021)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:36 BST 2024)
# 
#   net: phylink: add helpers for decoding mode
# 
#   Add helpers to decode the mode argument passed to the various MAC and
#   PCS functions.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   70c380b6b58d51d17ab3342e809329a69a37ac24
#    include/linux/phylink.h | 17 ++++++++++++++++-
#    1 file changed, 16 insertions(+), 1 deletion(-)
# 
# Author:    Russell King (Tue  3 Mar 12:12:43 GMT 2020)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:36 BST 2024)
# 
#   net: phylink: use phy interface mode bitmaps for SFP PHYs
# 
#   Select the initial SFP PHY interface mode from the PHY supported
#   interface bitmaps.
# 
#   Signed-off-by: Russell King
# 
#   cdf0803cee5ef0ae771dfc9195e0dcc5d2da5126
#    drivers/net/phy/phylink.c | 53 +++++++++++++++++++++++++++++++++++++++++++++--
#    1 file changed, 51 insertions(+), 2 deletions(-)
# 
# Author:    Russell King (Oracle) (Sat  5 Aug 14:30:51 BST 2023)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:36 BST 2024)
# 
#   net: phy: add supported_interfaces to Aquantia AQR113C
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   2ca0ca028cfdff5a8c2cf9b14088c1188c625f77
#    drivers/net/phy/aquantia/aquantia_main.c | 15 ++++++++++++++-
#    1 file changed, 14 insertions(+), 1 deletion(-)
# 
# Author:    Russell King (Mon 23 Dec 23:26:04 GMT 2019)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:35 BST 2024)
# 
#   net: phy: add supported_interfaces to marvell10g PHYs
# 
#   Signed-off-by: Russell King
# 
#   e19052609e276b2a5ea735eb101afeeacdc00037
#    drivers/net/phy/marvell10g.c | 5 ++---
#    1 file changed, 2 insertions(+), 3 deletions(-)
# 
# Author:    Russell King (Mon 23 Dec 23:25:49 GMT 2019)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:35 BST 2024)
# 
#   net: phy: add supported_interfaces to marvell PHYs
# 
#   Signed-off-by: Russell King
# 
#   2218cd1d988c9013b1ce90d0e09a5ae3550e1859
#    drivers/net/phy/marvell.c | 9 +++++++++
#    1 file changed, 9 insertions(+)
# 
# Author:    Russell King (Mon 23 Dec 23:25:35 GMT 2019)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:35 BST 2024)
# 
#   net: phy: add supported_interfaces to bcm84881
# 
#   Signed-off-by: Russell King
# 
#   30e14176927f3b84107439974d0d8edf642d8d93
#    drivers/net/phy/bcm84881.c | 4 ++++
#    1 file changed, 4 insertions(+)
# 
# Author:    Russell King (Mon 23 Dec 23:24:17 GMT 2019)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:34 BST 2024)
# 
#   net: phy: add supported_interfaces to phylib
# 
#   Add a supported_interfaces member to phylib so we know which
#   interfaces a PHY supports. Currently, set any unconverted driver
#   to indicate all interfaces are supported.
# 
#   Signed-off-by: Russell King
# 
#   f5af60810618158035eea7cfc31ca0a12fb058ac
#    include/linux/phy.h | 3 +++
#    1 file changed, 3 insertions(+)
# 
# Author:    Russell King (Sun 13 Sep 01:06:31 BST 2015)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:34 BST 2024)
# 
#   net: sfp: display SFP module information       [*not for mainline*]
# 
#   Display SFP module information verbosely, splitting the generic parts
#   into a separate file.
# 
#   Signed-off-by: Russell King
# 
#   4ac1a09c062a4d845794977fee8f60603293eb50
#    drivers/net/phy/Makefile |   2 +-
#    drivers/net/phy/sff.c    | 114 +++++++++++++++++++++++
#    drivers/net/phy/sff.h    |  16 ++++
#    drivers/net/phy/sfp.c    | 229 ++++++++++++++++++++++++++++++++++++++++++++---
#    4 files changed, 350 insertions(+), 11 deletions(-)
#    create mode 100644 drivers/net/phy/sff.c
#    create mode 100644 drivers/net/phy/sff.h
# 
# Author:    Russell King (Fri 14 Apr 20:17:13 BST 2017)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:34 BST 2024)
# 
#   net: sfp: add sfp+ compatible                  [*not for mainline*]
# 
#   Add a compatible for SFP+ cages.  SFP+ cages are backwards compatible,
#   but the ethernet device behind them may not support the slower speeds
#   of SFP modules.
# 
#   Signed-off-by: Russell King
# 
#   05296f411e6b7afbb64e436b7f19e4143451851a
#    drivers/net/phy/sfp.c | 1 +
#    1 file changed, 1 insertion(+)
# 
# Author:    Russell King (Fri 18 Oct 10:37:44 BST 2019)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:34 BST 2024)
# 
#   net: sfp: add support for cooled SFP+ transceivers
# 
#   Cooled SFP+ transceivers need a longer initialisation (startup) time.
#   Select the initialisation time depending on the cooled option bit.
# 
#   Signed-off-by: Russell King
# 
#   6be06ab228ad4e9f8cc24ad548829b70c4ce8f02
#    drivers/net/phy/sfp.c | 18 +++++++++++-------
#    1 file changed, 11 insertions(+), 7 deletions(-)
# 
# Author:    Russell King (Tue  5 Nov 10:34:39 GMT 2019)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:33 BST 2024)
# 
#   net: phy: make phy_error() report which PHY has failed
# 
#   phy_error() is called from phy_interrupt() or phy_state_machine(), and
#   uses WARN_ON() to print a backtrace. The backtrace is not useful when
#   reporting a PHY error.
# 
#   However, a system may contain multiple ethernet PHYs, and phy_error()
#   gives no clue which one caused the problem.
# 
#   Replace WARN_ON() with a call to phydev_err() so that we can see which
#   PHY had an error, and also inform the user that we are halting the PHY.
# 
#   Signed-off-by: Russell King
# 
#   7433873f8e0b7d72bacd8c1d40694d511bb6b482
#    drivers/net/phy/phy.c | 3 ++-
#    1 file changed, 2 insertions(+), 1 deletion(-)
# 
# Author:    Russell King (Wed  5 Jun 11:44:55 BST 2019)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:33 BST 2024)
# 
#   net: phy: marvell10g: allow PHY to probe without firmware
# 
#   Allow the PHY to probe when there is no firmware, but do not allow the
#   link to come up by forcing the PHY state to PHY_HALTED in a similar way
#   to phy_error().
# 
#   Signed-off-by: Russell King
# 
#   2513f83a736f2ca5416fb6d30aaa8d8cc8028f95
#    drivers/net/phy/marvell10g.c | 18 +++++++++++++++++-
#    1 file changed, 17 insertions(+), 1 deletion(-)
# 
# Author:    Russell King (Mon 26 Aug 12:19:35 BST 2019)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:33 BST 2024)
# 
#   net: phy: provide phy driver start/stop hooks
# 
#   Provide phy driver start/stop hooks so that the PHY driver knows when
#   the network driver is starting or stopping.  This will be used for the
#   Marvell 10G driver so that we can sanely refuse to start if the PHYs
#   firmware is not present, and also so that we can sanely support SFPs
#   behind the PHY.
# 
#   Signed-off-by: Russell King
# 
#   a7631777c26fe1ca15ab784ffb5687699733701c
#    drivers/net/phy/phy.c | 7 +++++++
#    include/linux/phy.h   | 3 +++
#    2 files changed, 10 insertions(+)
# 
# Author:    Russell King (Sat  4 Jan 00:41:35 GMT 2020)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:32 BST 2024)
# 
#   net: phy: marvell*: add support for hw resolved pause modes
# 
#   Support reporting the hardware resolved pause enablement states via
#   phylib, overriding our software implementation.
# 
#   Signed-off-by: Russell King
# 
#   f80ae90d00c1ad10e0388955e69303e0b0ecfb45
#    drivers/net/phy/marvell.c    | 40 ++++++++++++++++++++++++++++++++++------
#    drivers/net/phy/marvell10g.c |  6 ++++++
#    2 files changed, 40 insertions(+), 6 deletions(-)
# 
# Author:    Russell King (Fri  3 Jan 23:13:28 GMT 2020)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:32 BST 2024)
# 
#   net: phy: add resolved pause support           [*not for mainline*]
# 
#   Allow phylib drivers to pass the hardware-resolved pause state to MAC
#   drivers, rather than using the software-based pause resolution code.
# 
#   Signed-off-by: Russell King
# 
#   b7ca68de8215ba264e06160779cd7b1ff4909f6a
#    drivers/net/phy/phy_device.c | 6 ++++++
#    include/linux/phy.h          | 9 +++++++++
#    2 files changed, 15 insertions(+)
# 
# Author:    Russell King (Oracle) (Fri  2 Jun 11:51:53 BST 2023)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:32 BST 2024)
# 
#   net: phylink: handle MDIO_USXGMII_LINK when decoding USXGMII
# 
#   If MDIO_USXGMII_LINK is not set, it means that the PHYs media side
#   link is down. Indicate back to phylink that the link as a whole is
#   down.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   e4196183ef64aaf82265877e7b38211b706cf334
#    drivers/net/phy/phylink.c | 10 ++++++++--
#    1 file changed, 8 insertions(+), 2 deletions(-)
# 
# Author:    Russell King (Sun  1 Dec 15:35:08 GMT 2019)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:31 BST 2024)
# 
#   arm64: dts: configure Macchiatobin 10G PHY LED modes
# 
#   Configure the Macchiatobin 10G PHY LED modes to correct their polarity.
#   We keep the existing LED behaviours, but switch their polarity to
#   reflect how they are connected. Tweak the LED modes as well to be:
# 
#   left:  off          = no link
#          solid green  = RJ45 link up (not SFP+ cage)
#          flash green  = traffic
#   right: off          = no link
#          solid green  = 10G
#          solid yellow = 1G
#          flash green  = 100M
#          flash yellow = 10M
# 
#   Signed-off-by: Russell King
# 
#   4136835f24eb63294f17ac287f8049d36df990b3
#    arch/arm64/boot/dts/marvell/armada-8040-mcbin.dts | 2 ++
#    1 file changed, 2 insertions(+)
# 
# Author:    Russell King (Sun  1 Dec 15:33:39 GMT 2019)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:30 BST 2024)
# 
#   net: phy: marvell10g: add support for configuring LEDs
# 
#   Add support for configuring the LEDs. Macchiatobin has an oddity in
#   that the left LED goes out when the cable is connected, and flashes
#   when there's link activity. This is because the reset default for
#   the LED outputs assume that the LED is connected to supply, not to
#   ground. Add support for configuring the LED modes and polarities.
# 
#   Signed-off-by: Russell King
# 
#   79ca61a62c2f28a263c609c912c83c93b5ccc847
#    drivers/net/phy/marvell10g.c | 62 +++++++++++++++++++++++++++++++++++++++-----
#    1 file changed, 55 insertions(+), 7 deletions(-)
# 
# Author:    Russell King (Tue 17 Dec 15:21:50 GMT 2019)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:30 BST 2024)
# 
#   dt-bindings: net: add dt bindings for marvell10g driver
# 
#   Add a DT bindings document for the Marvell 10G driver, which will
#   augment the generic ethernet PHY binding by having LED mode
#   configuration.
# 
#   Signed-off-by: Russell King
# 
#   89990b631dcec62ebfac63805bc3832b63e85c97
#    .../devicetree/bindings/net/marvell,10g.yaml       | 36 ++++++++++++++++++++++
#    1 file changed, 36 insertions(+)
#    create mode 100644 Documentation/devicetree/bindings/net/marvell,10g.yaml
# 
# Author:    Russell King (Oracle) (Fri 26 Apr 10:59:38 BST 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:30 BST 2024)
# 
#   net: phylink: clean up phylink_resolve()
# 
#   The switch() statement doesn't sit very well with the preceeding if()
#   statements, so let's just convert everything to if()s. This allows
#   better formatting of the code.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   b165410302e7664d43b65fd89cf67beb49e3b84c
#    drivers/net/phy/phylink.c | 108 ++++++++++++++++++++++------------------------
#    1 file changed, 52 insertions(+), 56 deletions(-)
# 
# Author:    Russell King (Oracle) (Mon 22 Apr 17:24:46 BST 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:29 BST 2024)
# 
#   net: phylink: move manual flow control setting
# 
#   Move the handling of manual flow control configuration to a common
#   location during resolve. We currently evaluate this for all but
#   fixed links.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   50179d18e1f486ba75e6beddb004a410884c5ce4
#    drivers/net/phy/phylink.c | 5 +++--
#    1 file changed, 3 insertions(+), 2 deletions(-)
# 
# Author:    Russell King (Oracle) (Fri 26 Apr 15:58:29 BST 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:29 BST 2024)
# 
#   net: phylink: remove phylink_phy_no_inband()
# 
#   Remove phylink_phy_no_inband() now that we are handling the lack of
#   inband negotiation by querying the capabilities of the PHY and PCS,
#   and the BCM84881 PHY driver provides us the information necessary to
#   make the decision.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   a087002b1be26502d099c8edf2d2271108584268
#    drivers/net/phy/phylink.c | 27 ++++++---------------------
#    1 file changed, 6 insertions(+), 21 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu  8 Feb 16:12:43 GMT 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:29 BST 2024)
# 
#   net: phylink: add pcs_query_inband() *WIP*
# 
#   Add a pcs_query_inband() interface which reflects phy_query_inband()
#   for PHYs. This can be used to determine for the specified interface
#   mode whether in-band signalling is supported by the PCS, and whether
#   the PCS requires in-band signalling.
# 
#   This is used to determine whether we should use inband autonegotiation
#   in inband mode, which may be required or may be unsupported in various
#   interface modes.
# 
#   This revised version uses enable/disable/bypass flags to indicate the
#   capabilities.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   72309af067dfbd4c0cbc1a6af94aadc1ceeb1e8c
#    drivers/net/phy/phylink.c | 141 ++++++++++++++++++++++++++++++++++++++++------
#    1 file changed, 123 insertions(+), 18 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu  8 Feb 19:39:42 GMT 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:28 BST 2024)
# 
#   net: mvpp2: add support for querying PCS inband properties
# 
#   Report the PCS inband properties to phylink for Marvell PP2 interfaces.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   1f038bdcdc0248773258414a6a774b4175a3eff4
#    drivers/net/ethernet/marvell/mvpp2/mvpp2_main.c | 25 ++++++++++++++++---------
#    1 file changed, 16 insertions(+), 9 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu  8 Feb 16:41:31 GMT 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:28 BST 2024)
# 
#   net: mvneta: add support for querying PCS inband properties
# 
#   Report the PCS inband properties to phylink for Marvell NETA
#   interfaces.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   c7015cea5aa49154f4a675b4165d0847c4057be3
#    drivers/net/ethernet/marvell/mvneta.c | 27 +++++++++++++++++----------
#    1 file changed, 17 insertions(+), 10 deletions(-)
# 
# Author:    Russell King (Oracle) (Sat 27 Apr 12:03:27 BST 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:28 BST 2024)
# 
#   net: phylink: add pcs_query_inband() method
# 
#   Add a pcs_query_inband() method to query the PCS for its inband link
#   capabilities, and use this to determine whether link modes used with
#   optical SFPs can be supported.
# 
#   When a PCS does not provide a method, we allow inband negotiation to
#   be either on or off, making this a no-op until the pcs_query_inband()
#   method is implemented by a PCS driver.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   99852d52fe57297773c1143552dee332cdf5b341
#    drivers/net/phy/phylink.c | 60 +++++++++++++++++++++++++++++++++++++++++++++++
#    include/linux/phylink.h   | 17 ++++++++++++++
#    2 files changed, 77 insertions(+)
# 
# Author:    Russell King (Oracle) (Thu  8 Feb 15:54:46 GMT 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:28 BST 2024)
# 
#   net: phy: marvell: provide phy_query_inband() implementation
# 
#   Provide an implementation for phy_query_inband() for Marvell PHYs used
#   on SFP modules.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   427eabc80b67a10778b322b43b3b6c4d8fc02526
#    drivers/net/phy/marvell.c | 16 ++++++++++++++++
#    1 file changed, 16 insertions(+)
# 
# Author:    Russell King (Oracle) (Tue 30 Jan 14:38:27 GMT 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:27 BST 2024)
# 
#   net: phy: bcm84881: provide phy_query_inband() implementation
# 
#   BCM84881 has no support for inband signalling, so this is a trivial
#   implementation that returns no support for inband.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   6ea582b10cc3e5c373530ced629c248edef5bae7
#    drivers/net/phy/bcm84881.c | 10 ++++++++++
#    1 file changed, 10 insertions(+)
# 
# Author:    Russell King (Oracle) (Mon 21 Aug 13:04:32 BST 2023)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:27 BST 2024)
# 
#   net: phy: add phy_query_inband()
# 
#   Add a method to query the PHY's in-band capabilities for a PHY
#   interface mode. This can be used to determine for the specified
#   interface mode whether in-band signalling is supported, and whether
#   the PHY requires in-band signalling.
# 
#   When not implemented, or the PHY driver doesn't report any modes
#   for the interface, LINK_INBAND_VALID will not be set. When set, the
#   remainder of the flags can be interpreted.
# 
#   LINK_INBAND_POSSIBLE means that the device can be configured to use
#   or not use in-band signalling. Later patches may add support to
#   configure this at the PHY.
# 
#   LINK_INBAND_REQUIRED means that the device uses in-band signalling
#   which can not be disabled.
# 
#   When only LINK_INBAND_VALID has been set, this means that the device
#   does not support any in-band signalling, and can't be configured to
#   do so.
# 
#   "Bypass" mode (where the device may be configured for in-band, but
#   may still bring the link up if there is no in-band received from the
#   link partner) is not considered in this patch.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   2cf464c25db5f495a3ff0d0fecd2ebe12c6f102d
#    drivers/net/phy/phy.c | 21 +++++++++++++++++++++
#    include/linux/phy.h   | 28 ++++++++++++++++++++++++++++
#    2 files changed, 49 insertions(+)
# 
# Author:    Russell King (Oracle) (Fri 26 Apr 09:58:56 BST 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:27 BST 2024)
# 
#   net: phylink: move phylink_pcs_neg_mode() in phylink_major_config()
# 
#   Move the call to phylink_pcs_neg_mode() in phylink_major_config() after
#   we have selected the appropriate PCS to later allow the capabilities of
#   the PCS to be used when deciding which pcs_neg_mode should be used.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   193e76843e0600322bfadf3811ba276ac39b095c
#    drivers/net/phy/phylink.c | 8 ++++----
#    1 file changed, 4 insertions(+), 4 deletions(-)
# 
# Author:    Russell King (Oracle) (Sat 27 Apr 14:09:10 BST 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:26 BST 2024)
# 
#   net: phylink: add debug for phylink_major_config()
# 
#   Now that we have a more complexity in phylink_major_config(), augment
#   the debugging so we can see what's going on there.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   a9bb5d5403e0ac3c6471e88f9fab329deacf9422
#    drivers/net/phy/phylink.c | 27 ++++++++++++++++++++++++++-
#    1 file changed, 26 insertions(+), 1 deletion(-)
# 
# Author:    Russell King (Oracle) (Mon 22 Apr 16:44:44 BST 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:26 BST 2024)
# 
#   net: phylink: switch to MLO_AN_PHY when PCS uses outband
# 
#   phylink_pcs_neg_mode() currently only outband mode when we are using
#   MLO_AN_PHY or MLO_AN_FIXED. However, we want to extend the use of this
#   to MLO_AN_INBAND when the PCS and/or PHY are unable to use inband mode.
# 
#   For example, when a PHY is not capable of supporting inband mode, we
#   need to operate in outband mode. However, using outband mode for the
#   PCS while using MLO_AN_INBAND causes drivers to misbehave as it is not
#   a situation they are expecting. Therefore, we need to switch to
#   MLO_AN_PHY when using outband mode.
# 
#   Add the logic to select MLO_AN_PHY mode when phylink_pcs_neg_mode()
#   indicates that it will be using outband mode with a PHY and the
#   requested mode is MLO_AN_INBAND.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   33eadbebbb0746c4d4f1223f867621b1818a91e7
#    drivers/net/phy/phylink.c | 19 +++++++++++++++++--
#    1 file changed, 17 insertions(+), 2 deletions(-)
# 
# Author:    Russell King (Oracle) (Fri 26 Apr 10:30:39 BST 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:26 BST 2024)
# 
#   net: phylink: split cur_link_an_mode into requested and active
# 
#   There is an interdependence between the link_an_mode and pcs_neg_mode
#   that at least drivers rely upon. In order to support changing the MAC
#   link_an_mode when we switch interfaces, we need to keep track of its
#   original setting so that we can appropriately re-calculate pcs_neg_mode
#   from the same starting point.
# 
#   Split the current link_an_mode into a requested link_an_mode and an
#   active link_an_mode. This will allow us to keep the MAC's link_an_mode
#   synchronised with the pcs_neg_mode should we decide to switch to
#   outband with a PHY.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   aca110fd5a9be9aaf2f8fb9c30a7a9526f764863
#    drivers/net/phy/phylink.c | 60 ++++++++++++++++++++++++++---------------------
#    1 file changed, 33 insertions(+), 27 deletions(-)
# 
# Author:    Russell King (Oracle) (Fri 26 Apr 13:04:32 BST 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:26 BST 2024)
# 
#   net: phylink: simplify how SFP PHYs are attached
# 
#   There are a few issues with how SFP PHYs are attached:
# 
#   a) The phylink_sfp_connect_phy() and phylink_sfp_config_phy() code
#      validates the configuration three times:
# 
#   1. To discover the support/advertising masks that the PHY/PCS/MAC
#      can support in order to select an interface.
#   2. To validate the selected interface.
#   3. When the PHY is brought up after being attached, another validation
#      is done.
# 
#      This is needlessly complex.
# 
#   b) The configuration is set prior to the PHY being attached, which
#      means we don't have the PHY available in phylink_major_config()
#      for phylink_pcs_neg_mode() to make decisions upon.
# 
#   We have already added an extra step to validate the selected interface,
#   so we can now move the attachment and bringup of the PHY earlier,
#   inside phylink_sfp_config_phy(). This results in the validation at
#   step 2 above becoming entirely unnecessary, so remove that too.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   f889c15c30e388b199cfdc224dbf9410977827dd
#    drivers/net/phy/phylink.c | 43 ++++++++++++++-----------------------------
#    1 file changed, 14 insertions(+), 29 deletions(-)
# 
# Author:    Russell King (Oracle) (Fri 26 Apr 12:58:22 BST 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:25 BST 2024)
# 
#   net: phylink: validate sfp_select_interface() returned interface
# 
#   When configuring for a SFP PHY, validate that the MAC supports the
#   interface returned from sfp_select_interface(). This is a preparatory
#   step to reorganising how a PHY on a SFP module is handled.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   3236566589b28eaa636890d9c5fcbb8b003f4d9d
#    drivers/net/phy/phylink.c | 43 ++++++++++++++++++++++++++++++-------------
#    1 file changed, 30 insertions(+), 13 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu  1 Jun 09:48:20 BST 2023)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:25 BST 2024)
# 
#   net: phylink: allow EEE management for SFPs without PHYs
# 
#   Allow EEE management for SFPs without accessible PHYs.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   a790044d9ea65c36028d483cbd358c8980d94bd6
#    drivers/net/phy/phylink.c | 11 ++++++++++-
#    1 file changed, 10 insertions(+), 1 deletion(-)
# 
# Author:    Russell King (Oracle) (Wed 16 Aug 20:48:48 BST 2023)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:25 BST 2024)
# 
#   net: dsa: mt7530: convert to phylink managed EEE
# 
#   Fixme: doesn't bit 25 and 26 also need to be set in the PMCR for
#   PMCR_FORCE_EEE100 and PMCR_FORCE_EEE1G to take effect?
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   9e983f5441ce9f3f2fd1b2c28b0434f28aa0ab1a
#    drivers/net/dsa/mt7530.c | 98 ++++++++++++++++++++++++++----------------------
#    drivers/net/dsa/mt7530.h |  6 +--
#    2 files changed, 54 insertions(+), 50 deletions(-)
# 
# Author:    Russell King (Oracle) (Wed 16 Aug 14:02:11 BST 2023)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:24 BST 2024)
# 
#   net: dsa: add support for phylink managed EEE
# 
#   Add support to allow DSA drivers to use phylink managed EEE, with only
#   needing support for controlling the LPI state.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   459eee339d6795e6d71a83100712fa8fdd1a6ee0
#    net/dsa/user.c | 42 ++++++++++++++++++++++++++----------------
#    1 file changed, 26 insertions(+), 16 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 17 Aug 16:32:32 BST 2023)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:24 BST 2024)
# 
#   net: dsa: mv88e6xxx: add EEE controls
# 
#   Add phylink EEE control methods to allow EEE to be configured. When
#   LPI is to be disabled, we force the port to have EEE disabled, but
#   when enabling EEE, if the port is under the control of the PPU, we
#   stop forcing it, otherwise we force-enable EEE.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   12943f7447dfdd36c7b118b4970a733419be219a
#    drivers/net/dsa/mv88e6xxx/chip.c | 45 ++++++++++++++++++++++++++++++++++++++++
#    1 file changed, 45 insertions(+)
# 
# Author:    Russell King (Oracle) (Thu 17 Aug 15:36:22 BST 2023)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:24 BST 2024)
# 
#   net: dsa: mv88e6xxx: add support for EEE forcing
# 
#   Add support for EEE forcing using the MAC control register. Replace
#   the 88e6393x errata 4.5 EEE disable code with a call to the new EEE
#   forcing code.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   a37fa764f67d7b33cfa9a22d8ce3e1bf00b8d284
#    drivers/net/dsa/mv88e6xxx/port.c | 39 +++++++++++++++++++++++++++++++--------
#    drivers/net/dsa/mv88e6xxx/port.h |  1 +
#    2 files changed, 32 insertions(+), 8 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 17 Aug 16:32:32 BST 2023)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:23 BST 2024)
# 
#   net: dsa: mv88e6xxx: add port_set_eee() method
# 
#   Add a port_set_eee() method to allow the EEE settings for a port to be
#   configured.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   9169749e782b58bfd580146469157142a3225a83
#    drivers/net/dsa/mv88e6xxx/chip.h | 10 ++++++++++
#    1 file changed, 10 insertions(+)
# 
# Author:    Russell King (Oracle) (Wed 31 May 17:17:11 BST 2023)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:23 BST 2024)
# 
#   net: mvpp2: add EEE implementation
# 
#   Add EEE support for mvpp2, using phylink's EEE implementation, which
#   means we just need to implement the two methods for LPI control, and
#   with the initial configuration. Only the GMAC is supported, so only
#   100M, 1G and 2.5G speeds.
# 
#   Disabling LPI requires clearing a single bit. Enabling LPI needs a full
#   configuration of several values, as the timer values are dependent on
#   the MAC operating speed.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   ce02531f81a7bcc00ed074c82744e0baec2d2de0
#    drivers/net/ethernet/marvell/mvpp2/mvpp2.h      |  5 ++
#    drivers/net/ethernet/marvell/mvpp2/mvpp2_main.c | 85 +++++++++++++++++++++++++
#    2 files changed, 90 insertions(+)
# 
# Author:    Russell King (Oracle) (Wed 31 May 15:17:24 BST 2023)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:23 BST 2024)
# 
#   net: mvneta: convert to phylink EEE implementation
# 
#   Convert mvneta to use phylink's EEE implementation, which means we just
#   need to implement the two methods for LPI control, and adding the
#   initial configuration.
# 
#   Disabling LPI requires clearing a single bit. Enabling LPI needs a full
#   configuration of several values, as the timer values are dependent on
#   the MAC operating speed.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   08de07efdb45669a70dffb74b28722cc0d941bf0
#    drivers/net/ethernet/marvell/mvneta.c | 107 +++++++++++++++++++---------------
#    1 file changed, 60 insertions(+), 47 deletions(-)
# 
# Author:    Russell King (Oracle) (Wed 31 May 10:02:35 BST 2023)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:22 BST 2024)
# 
#   net: phylink: add EEE management
# 
#   Add EEE management to phylink.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   7dffe465e60c13801a6d51edfcd70f0b306b7bdd
#    drivers/net/phy/phylink.c | 135 +++++++++++++++++++++++++++++++++++++++++++++-
#    include/linux/phylink.h   |  36 +++++++++++++
#    2 files changed, 170 insertions(+), 1 deletion(-)
# 
# Author:    Russell King (Oracle) (Wed 31 May 10:02:35 BST 2023)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:40:22 BST 2024)
# 
#   net: phylink: add phylink_link_is_up() helper
# 
#   Add a helper to determine whether the link is up or down. Currently
#   this is only used in one location, but becomes necessary to test
#   when reconfiguring EEE.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   5e19b9b1a2094cb380519997c447fb63018bee27
#    drivers/net/phy/phylink.c | 10 ++++++----
#    1 file changed, 6 insertions(+), 4 deletions(-)
# 
# Author:    Russell King (Oracle) (Fri 24 May 22:04:13 BST 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:37:33 BST 2024)
# 
#   net: dsa: remove obsolete phylink dsa_switch operations
# 
#   No driver now uses the DSA switch phylink members, so we can now remove
#   the shim functions and method pointers. Arrange to print an error
#   message and fail registration if a DSA driver does not provide the
#   phylink MAC operations structure.
# 
#   Signed-off-by: Russell King (oracle)
# 
#   a83ceb824a2f91d76e95639c9f850b78d62e4ab7
#    net/dsa/dsa.c  |  5 +++++
#    net/dsa/port.c | 34 +---------------------------------
#    2 files changed, 6 insertions(+), 33 deletions(-)
# 
# Author:    Russell King (Oracle) (Fri 18 Oct 10:35:33 BST 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:36:03 BST 2024)
# 
#   net: phylink: simplify phylink_parse_fixedlink()
# 
#   phylink_parse_fixedlink() wants to preserve the pause, asym_pause and
#   autoneg bits in pl->supported. Rather than reading the bits into
#   separate bools, zeroing pl->supported, and then setting them if they
#   were previously set, use a mask and linkmode_and() to achieve the same
#   result.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   7a2612b21b8ee64badb20ca193d1eeb728d1dfc3
#    drivers/net/phy/phylink.c | 19 ++++++-------------
#    1 file changed, 6 insertions(+), 13 deletions(-)
# 
# Author:    Russell King (Oracle) (Fri 18 Oct 10:35:13 BST 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:36:03 BST 2024)
# 
#   net: phylink: remove "using_mac_select_pcs"
# 
#   With DSA's implementation of the mac_select_pcs() method removed, we
#   can now remove the detection of mac_select_pcs() implementation.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   fb2dbb27e96002032defb0d2fd6a7dae0574a210
#    drivers/net/phy/phylink.c | 12 ++----------
#    1 file changed, 2 insertions(+), 10 deletions(-)
# 
# Author:    Russell King (Oracle) (Fri 18 Oct 10:35:13 BST 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:36:02 BST 2024)
# 
#   net: phylink: remove use of pl->pcs in phylink_validate_mac_and_pcs()
# 
#   When the mac_select_pcs() method is not implemented, there is no way
#   for pl->pcs to be set to a non-NULL value. This was here to support
#   the old phylink_set_pcs() method which has been removed a few years
#   ago. Simplify the code in phylink_validate_mac_and_pcs().
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   d4713f12599e6ff49738ab9485e26fe296547985
#    drivers/net/phy/phylink.c | 4 +---
#    1 file changed, 1 insertion(+), 3 deletions(-)
# 
# Author:    Russell King (Oracle) (Fri 18 Oct 10:35:13 BST 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:36:02 BST 2024)
# 
#   net: phylink: allow mac_select_pcs() to remove a PCS
# 
#   phylink has historically not permitted a PCS to be removed. An attempt
#   to permit this with phylink_set_pcs() resulted in comments indicating
#   that there was no need for this. This behaviour has been propagated
#   forward to the mac_select_pcs() approach as it was believed from these
#   comments that changing this would be NAK'd.
# 
#   However, with mac_select_pcs(), it takes more code and thus complexity
#   to maintain this behaviour, which can - and in this case has - resulted
#   in a bug. If mac_select_pcs() returns NULL for a particular interface
#   type, but there is already a PCS in-use, then we skip the pcs_validate()
#   method, but continue using the old PCS. Also, it wouldn't be expected
#   behaviour by implementers of mac_select_pcs().
# 
#   Allow this by removing this old unnecessary restriction.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   b4858d43a97e6c213f9b647d07d7923a9f4eba21
#    drivers/net/phy/phylink.c | 2 +-
#    1 file changed, 1 insertion(+), 1 deletion(-)
# 
# Author:    Russell King (Oracle) (Fri 18 Oct 10:35:12 BST 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:36:02 BST 2024)
# 
#   net: dsa: mv88e6xxx: return NULL when no PCS is present
# 
#   Rather than returning an EOPNOTSUPP error pointer when the switch
#   has no support for PCS, return NULL to indicate that no PCS is
#   required.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   9e14ae9465303c8959dd8bf37878dc66a85ac43d
#    drivers/net/dsa/mv88e6xxx/chip.c | 2 +-
#    1 file changed, 1 insertion(+), 1 deletion(-)
# 
# Author:    Russell King (Oracle) (Fri 18 Oct 10:35:12 BST 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:36:02 BST 2024)
# 
#   net: dsa: remove dsa_port_phylink_mac_select_pcs()
# 
#   There is no longer any reason to implement the mac_select_pcs()
#   callback in DSA. Returning ERR_PTR(-EOPNOTSUPP) is functionally
#   equivalent to not providing the function.
# 
#   Signed-off-by: Russell King (Oracle)
# 
#   483a52c200b85fbcf812be55f6b7fcd996671666
#    net/dsa/port.c | 8 --------
#    1 file changed, 8 deletions(-)
# 
# Author:    Russell King (Oracle) (Fri 18 Oct 10:35:05 BST 2024)
# Committer: Russell King (Oracle) (Fri 18 Oct 10:36:01 BST 2024)
# 
#   net: dsa: remove obsolete phylink dsa_switch operations
# 
#   No driver now uses the DSA switch phylink members, so we can now remove
#   the method pointers, but we need to leave empty shim functions to allow
#   those drivers that do not provide phylink MAC operations structure to
#   continue functioning.
# 
#   Signed-off-by: Russell King (oracle)
#   Reviewed-by: Vladimir Oltean
#   Tested-by: Vladimir Oltean # sja1105, felix, dsa_loop
#   Link: https://patch.msgid.link/E1swKNV-0060oN-1b@rmk-PC.armlinux.org.uk
#   Signed-off-by: Jakub Kicinski
# 
#   25b6615e4c78f8d207fc9f6c88b6424628182da3
#    include/net/dsa.h | 15 ---------------
#    net/dsa/dsa.c     |  8 --------
#    net/dsa/port.c    | 34 +---------------------------------
#    3 files changed, 1 insertion(+), 56 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:14:37 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:37 BST 2024)
# 
#   net: pcs: xpcs: move Wangxun VR_XS_PCS_DIG_CTRL1 configuration
# 
#   According to commits 2a22b7ae2fa3 ("net: pcs: xpcs: adapt Wangxun NICs
#   for SGMII mode") and 2deea43f386d ("net: pcs: xpcs: add 1000BASE-X AN
#   interrupt support"), Wangxun devices need special VR_XS_PCS_DIG_CTRL1
#   settings for SGMII and 1000BASE-X. Both SGMII and 1000BASE-X use the
#   same settings.
# 
#   Rather than placing these in the individual xpcs_config_*() functions,
#   move it to where we already test for the Wangxun devices in
#   xpcs_do_config().
# 
#   Signed-off-by: Russell King (Oracle)
#   Signed-off-by: David S. Miller
# 
#   dc770f983ce9175aeb5959930e13bee4178e4961
#    drivers/net/pcs/pcs-xpcs.c | 14 ++++++++------
#    1 file changed, 8 insertions(+), 6 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:14:37 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:37 BST 2024)
# 
#   net: pcs: xpcs: correctly place DW_VR_MII_DIG_CTRL1_2G5_EN
# 
#   Place DW_VR_MII_DIG_CTRL1_2G5_EN with the other DW_VR_MII_DIG_CTRL1
#   definitions rather than in the middle of a register list.
# 
#   Signed-off-by: Russell King (Oracle)
#   Signed-off-by: David S. Miller
# 
#   a21044ac9b90c712c72239c49ba4202709707f4f
#    drivers/net/pcs/pcs-xpcs.h | 3 +--
#    1 file changed, 1 insertion(+), 2 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:14:36 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:36 BST 2024)
# 
#   net: pcs: xpcs: use dev_*() to print messages
# 
#   Use the dev_*() family of functions to print all messages from the XPCS
#   driver so we know which instance issues the messages.
# 
#   Signed-off-by: Russell King (Oracle)
#   Signed-off-by: David S. Miller
# 
#   0ac9f2cb9e7cf916a9e6955e483329912a399b71
#    drivers/net/pcs/pcs-xpcs.c | 44 ++++++++++++++++++++++----------------------
#    1 file changed, 22 insertions(+), 22 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:14:36 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:36 BST 2024)
# 
#   net: pcs: xpcs: convert to use read_poll_timeout()
# 
#   Convert the xpcs driver to use read_poll_timeout() when waiting for
#   reset to complete, rather than open-coding this.
# 
#   Signed-off-by: Russell King (Oracle)
#   Signed-off-by: David S. Miller
# 
#   32fa243acd5a36131604ad4985e2030dd34f5256
#    drivers/net/pcs/pcs-xpcs.c | 17 +++++++----------
#    1 file changed, 7 insertions(+), 10 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:14:36 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:36 BST 2024)
# 
#   net: pcs: xpcs: add _modify() accessors
# 
#   The xpcs driver does a lot of read-modify-write operations on
#   registers, which leads to long-winded code to read the register, check
#   whether the read was successful, modify the value in some way, and then
#   write it back.
# 
#   We have a mdiodev _modify() accessor that encapsulates this, and does
#   the register modification under the MDIO bus lock ensuring that the
#   modification is atomic with respect to other bus operations. Convert
#   the xpcs driver to use this accessor.
# 
#   Signed-off-by: Russell King (Oracle)
#   Signed-off-by: David S. Miller
# 
#   eca8cfb56c333e5daff4e2742c3e2d37f514bd8c
#    drivers/net/pcs/pcs-xpcs-nxp.c |  24 ++----
#    drivers/net/pcs/pcs-xpcs-wx.c  |  56 ++++++--------
#    drivers/net/pcs/pcs-xpcs.c     | 165 ++++++++++++++++++-----------------------
#    drivers/net/pcs/pcs-xpcs.h     |   1 +
#    4 files changed, 104 insertions(+), 142 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:14:35 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:35 BST 2024)
# 
#   net: pcs: xpcs: use FIELD_PREP() and FIELD_GET()
# 
#   Convert xpcs to use the bitfield macros rather than definining the
#   bitfield shifts and open-coding the insertion and extraction of these
#   bitfields.
# 
#   Signed-off-by: Russell King (Oracle)
#   Signed-off-by: David S. Miller
# 
#   eb5245c70009276c52a9ec9000f1cd235ce1c31e
#    drivers/net/pcs/pcs-xpcs.c | 14 ++++++--------
#    drivers/net/pcs/pcs-xpcs.h |  4 ----
#    2 files changed, 6 insertions(+), 12 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:14:35 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:35 BST 2024)
# 
#   net: pcs: xpcs: move searching ID list out of line
# 
#   Move the searching of the physical ID out of xpcs_create() and into
#   its own xpcs_identify() function, which makes it self contained.
#   This reduces the complexity in xpcs_craete(), making it easier to
#   follow, rather than having a lot of once-run code in the big for()
#   loop.
# 
#   Signed-off-by: Russell King (Oracle)
#   Signed-off-by: David S. Miller
# 
#   dffe211a790ffd43f59f4cd97ce3de4ea57f8af8
#    drivers/net/pcs/pcs-xpcs.c | 41 +++++++++++++++++++++--------------------
#    1 file changed, 21 insertions(+), 20 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:14:35 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:35 BST 2024)
# 
#   net: pcs: xpcs: rename xpcs_get_id()
# 
#   Rename xpcs_get_id() to xpcs_read_id() which more closely reflects
#   the purpose of this function.
# 
#   Signed-off-by: Russell King (Oracle)
#   Signed-off-by: David S. Miller
# 
#   cd681b84d96d92da95ff217ddfa3a3babf827366
#    drivers/net/pcs/pcs-xpcs.c | 4 ++--
#    1 file changed, 2 insertions(+), 2 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:14:34 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:34 BST 2024)
# 
#   net: pcs: xpcs: move definition of struct dw_xpcs to private header
# 
#   There should be no reason for anything outside the XPCS code to know
#   the contents of struct dw_xpcs - this is a private structure to XPCS.
#   Move the definition to the private pcs-xpcs.h header, leaving a
#   declaration in the global pcs/pcs-xpcs.h
# 
#   Signed-off-by: Russell King (Oracle)
#   Signed-off-by: David S. Miller
# 
#   80e5323ca90d6e12eddd8f81bd25fe6361ea4fc3
#    drivers/net/pcs/pcs-xpcs.h   | 18 ++++++++++++++++++
#    include/linux/pcs/pcs-xpcs.h | 18 +-----------------
#    2 files changed, 19 insertions(+), 17 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:14:34 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:34 BST 2024)
# 
#   net: pcs: xpcs: provide a helper to get the phylink pcs given xpcs
# 
#   Provide a helper to provide the pointer to the phylink_pcs struct
#   given a valid xpcs pointer. This will be necessary when we make
#   struct dw_xpcs private to pcs-xpcs.c
# 
#   Signed-off-by: Russell King (Oracle)
#   Signed-off-by: David S. Miller
# 
#   d24a4b2c633a6eef2b53bdecb532f86cd416f404
#    drivers/net/ethernet/stmicro/stmmac/dwmac-intel.c | 2 +-
#    drivers/net/pcs/pcs-xpcs.c                        | 6 ++++++
#    include/linux/pcs/pcs-xpcs.h                      | 1 +
#    3 files changed, 8 insertions(+), 1 deletion(-)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:14:34 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:34 BST 2024)
# 
#   net: pcs: xpcs: pass xpcs instead of xpcs->id to xpcs_find_compat()
# 
#   xpcs_find_compat() is now always passed xpcs->id. Rather than always
#   dereferencing this in the caller, move it into xpcs_find_compat(),
#   thus making this function consistent with most of the other xpcs
#   functions in taking an xpcs pointer.
# 
#   Signed-off-by: Russell King (Oracle)
#   Signed-off-by: David S. Miller
# 
#   c3c3b82c7599e5e24c65504b5ba853da9df4c54d
#    drivers/net/pcs/pcs-xpcs.c | 14 +++++++-------
#    1 file changed, 7 insertions(+), 7 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:14:34 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:34 BST 2024)
# 
#   net: pcs: xpcs: don't use array for interface
# 
#   Currently, xpcs uses an array of interfaces that each "compat" entry
#   supports. When looking up the compat entry for an interface, we
#   iterate over the compat entries and then over each interface.
# 
#   Since each compat entry only has a single interface in its interfaces
#   array, replace the array with a single member in the compat structure.
# 
#   Signed-off-by: Russell King (Oracle)
#   Signed-off-by: David S. Miller
# 
#   2d9ff35bb97ea222fa98f5be73fdb434a259bdd9
#    drivers/net/pcs/pcs-xpcs.c | 71 +++++++++-------------------------------------
#    1 file changed, 14 insertions(+), 57 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:14:33 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:33 BST 2024)
# 
#   net: pcs: xpcs: remove dw_xpcs_compat enum
# 
#   There is no reason for the struct dw_xpcs_compat arrays to be a fixed
#   size other than the way we iterate over them. The index into the array
#   isn't used for anything, and having them fixed size needlessly wastes
#   space.
# 
#   Remove the enum that defines their size, and instead use an empty
#   array entry (with NULL ->supported) to mark the end of the array.
# 
#   Signed-off-by: Russell King (Oracle)
#   Signed-off-by: David S. Miller
# 
#   523bd58de2d373f0f229a40540a7cad560de4c14
#    drivers/net/pcs/pcs-xpcs.c | 69 +++++++++++++++++-----------------------------
#    1 file changed, 25 insertions(+), 44 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:10:59 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:18 BST 2024)
# 
#   net: pcs: xpcs: make xpcs_do_config() and xpcs_link_up() internal
# 
#   As nothing outside pcs-xpcs.c calls neither xpcs_do_config() nor
#   xpcs_link_up(), remove their exports and prototypes.
# 
#   Reviewed-by: Vladimir Oltean
#   Signed-off-by: Russell King (Oracle)
#   Link: https://patch.msgid.link/E1svfMv-005ZIv-2M@rmk-PC.armlinux.org.uk
#   Signed-off-by: Jakub Kicinski
# 
#   325088cc386197039507d6acb9474ca680608bb4
#    drivers/net/pcs/pcs-xpcs.c   | 11 +++++------
#    include/linux/pcs/pcs-xpcs.h |  4 ----
#    2 files changed, 5 insertions(+), 10 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:10:58 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:18 BST 2024)
# 
#   net: pcs: xpcs: drop interface argument from xpcs_create*()
# 
#   The XPCS sub-driver no longer uses the "interface" argument to the
#   xpcs_create_mdiodev() and xpcs_create_fwnode() functions. Remove
#   this now unnecessary argument, updating the stmmac driver
#   appropriately.
# 
#   Reviewed-by: Vladimir Oltean
#   Signed-off-by: Russell King (Oracle)
#   Link: https://patch.msgid.link/E1svfMp-005ZIp-UX@rmk-PC.armlinux.org.uk
#   Signed-off-by: Jakub Kicinski
# 
#   07e688f02f8d1f18e6a2dccf1a8187248abec307
#    drivers/net/ethernet/stmicro/stmmac/stmmac_mdio.c |  7 +++----
#    drivers/net/pcs/pcs-xpcs.c                        | 10 +++-------
#    include/linux/pcs/pcs-xpcs.h                      |  6 ++----
#    3 files changed, 8 insertions(+), 15 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:10:58 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:17 BST 2024)
# 
#   net: dsa: sja1105: use phylink_pcs internally
# 
#   Use xpcs_create_pcs_mdiodev() to create the XPCS instance, storing
#   and using the phylink_pcs pointer internally, rather than dw_xpcs.
#   Use xpcs_destroy_pcs() to destroy the XPCS instance when we've
#   finished with it.
# 
#   Signed-off-by: Russell King (Oracle)
#   Link: https://patch.msgid.link/E1svfMk-005ZIj-R3@rmk-PC.armlinux.org.uk
#   Signed-off-by: Jakub Kicinski
# 
#   2f7779d321d93cd9de17d02a64baeabc7c4ca58c
#    drivers/net/dsa/sja1105/sja1105.h      |  2 +-
#    drivers/net/dsa/sja1105/sja1105_main.c | 16 ++++------------
#    drivers/net/dsa/sja1105/sja1105_mdio.c | 28 +++++++++++++---------------
#    3 files changed, 18 insertions(+), 28 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:10:58 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:17 BST 2024)
# 
#   net: dsa: sja1105: call PCS config/link_up via pcs_ops structure
# 
#   Call the PCS operations through the ops structure, which avoids needing
#   to export xpcs internal functions.
# 
#   Signed-off-by: Russell King (Oracle)
#   Link: https://patch.msgid.link/E1svfMf-005ZId-Mx@rmk-PC.armlinux.org.uk
#   Signed-off-by: Jakub Kicinski
# 
#   d7c6202f6ca1e981c2e94d0601aff8333dfb6ac4
#    drivers/net/dsa/sja1105/sja1105_main.c | 10 +++++++---
#    1 file changed, 7 insertions(+), 3 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:10:57 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:17 BST 2024)
# 
#   net: dsa: sja1105: simplify static configuration reload
# 
#   The static configuration reload saves the port speed in the static
#   configuration tables by first converting it from the internal
#   respresentation to the SPEED_xxx ethtool representation, and then
#   converts it back to restore the setting. This is because
#   sja1105_adjust_port_config() takes the speed as SPEED_xxx.
# 
#   However, this is unnecessarily complex. If we split
#   sja1105_adjust_port_config() up, we can simply save and restore the
#   mac[port].speed member in the static configuration tables.
# 
#   Signed-off-by: Russell King (Oracle)
#   Link: https://patch.msgid.link/E1svfMa-005ZIX-If@rmk-PC.armlinux.org.uk
#   Signed-off-by: Jakub Kicinski
# 
#   72295265c6cb86ce3dce5e33ab385cbee5bcec51
#    drivers/net/dsa/sja1105/sja1105_main.c | 65 ++++++++++++++++++----------------
#    1 file changed, 34 insertions(+), 31 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:10:57 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:16 BST 2024)
# 
#   net: wangxun: txgbe: use phylink_pcs internally
# 
#   Use xpcs_create_pcs_mdiodev() to create the XPCS instance, storing
#   and using the phylink_pcs pointer internally, rather than dw_xpcs.
#   Use xpcs_destroy_pcs() to destroy the XPCS instance when we've
#   finished with it.
# 
#   Signed-off-by: Russell King (Oracle)
#   Reviewed-by: Andrew Lunn
#   Link: https://patch.msgid.link/E1svfMV-005ZIR-FE@rmk-PC.armlinux.org.uk
#   Signed-off-by: Jakub Kicinski
# 
#   af8353842089477c1bc9014b9c9dcc24793b839b
#    drivers/net/ethernet/wangxun/txgbe/txgbe_phy.c  | 18 +++++++++---------
#    drivers/net/ethernet/wangxun/txgbe/txgbe_type.h |  2 +-
#    2 files changed, 10 insertions(+), 10 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:10:57 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:16 BST 2024)
# 
#   net: pcs: xpcs: add xpcs_destroy_pcs() and xpcs_create_pcs_mdiodev()
# 
#   Provide xpcs create/destroy functions that return and take a phylink_pcs
#   pointer instead of an xpcs pointer. This will be used by drivers that
#   have been converted to use phylink_pcs pointers internally, rather than
#   dw_xpcs pointers.
# 
#   As xpcs_create_mdiodev() no longer makes use of its interface argument,
#   pass PHY_INTERFACE_MODE_NA into xpcs_create_mdiodev() until it is
#   removed later in the series.
# 
#   Reviewed-by: Vladimir Oltean
#   Signed-off-by: Russell King (Oracle)
#   Link: https://patch.msgid.link/E1svfMQ-005ZIL-Bi@rmk-PC.armlinux.org.uk
#   Signed-off-by: Jakub Kicinski
# 
#   b63243460de5a1a63309b5cf8d9f14db102cf65d
#    drivers/net/pcs/pcs-xpcs.c   | 18 ++++++++++++++++++
#    include/linux/pcs/pcs-xpcs.h |  3 +++
#    2 files changed, 21 insertions(+)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:10:56 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:16 BST 2024)
# 
#   net: pcs: xpcs: get rid of xpcs_init_iface()
# 
#   xpcs_init_iface() no longer does anything with the interface mode, and
#   now merely does configuration related to the PMA ID. Move this back
#   into xpcs_create() as it doesn't warrant being a separate function
#   anymore.
# 
#   Reviewed-by: Vladimir Oltean
#   Signed-off-by: Russell King (Oracle)
#   Link: https://patch.msgid.link/E1svfML-005ZIF-84@rmk-PC.armlinux.org.uk
#   Signed-off-by: Jakub Kicinski
# 
#   3370bc0ff82859ccead5037e7cc9fefe5ad50809
#    drivers/net/pcs/pcs-xpcs.c | 17 ++++-------------
#    1 file changed, 4 insertions(+), 13 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:10:56 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:16 BST 2024)
# 
#   net: pcs: xpcs: drop interface argument from internal functions
# 
#   Now that we no longer use the "interface" argument when creating the
#   XPCS sub-driver, remove it from xpcs_create() and xpcs_init_iface().
# 
#   Reviewed-by: Vladimir Oltean
#   Signed-off-by: Russell King (Oracle)
#   Link: https://patch.msgid.link/E1svfMG-005ZI9-3k@rmk-PC.armlinux.org.uk
#   Signed-off-by: Jakub Kicinski
# 
#   f72fd50ed5cfdcc017f3ccb534543a122f0ec507
#    drivers/net/pcs/pcs-xpcs.c | 11 +++++------
#    1 file changed, 5 insertions(+), 6 deletions(-)
# 
# Author:    Russell King (Oracle) (Thu 10 Oct 18:10:56 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:14:15 BST 2024)
# 
#   net: pcs: xpcs: move PCS reset to .pcs_pre_config()
# 
#   Move the PCS reset to .pcs_pre_config() rather than at creation time,
#   which means we call the reset function with the interface that we're
#   actually going to be using to talk to the downstream device.
# 
#   Reviewed-by: Vladimir Oltean
#   Tested-by: Vladimir Oltean # sja1105
#   Signed-off-by: Russell King (Oracle)
#   Tested-by: for them?
#   Link: https://patch.msgid.link/E1svfMA-005ZI3-Va@rmk-PC.armlinux.org.uk
#   Signed-off-by: Jakub Kicinski
# 
#   8984bddae8e8e6768b10bcec7268a293f21812ca
#    drivers/net/pcs/pcs-xpcs.c   | 39 +++++++++++++++++++++++++++++----------
#    include/linux/pcs/pcs-xpcs.h |  1 +
#    2 files changed, 30 insertions(+), 10 deletions(-)
# 
# Author:    Jiawen Wu (Thu 10 Oct 18:13:43 BST 2024)
# Committer: Russell King (Oracle) (Thu 10 Oct 18:13:43 BST 2024)
# 
#   net: pcs: xpcs: fix the wrong register that was written back
# 
#   The value is read from the register TXGBE_RX_GEN_CTL3, and it should be
#   written back to TXGBE_RX_GEN_CTL3 when it changes some fields.
# 
#   Cc: stable@vger.kernel.org
#   Fixes: f629acc6f210 ("net: pcs: xpcs: support to switch mode for Wangxun NICs")
#   Signed-off-by: Jiawen Wu
#   Reported-by: Russell King (Oracle)
#   Reviewed-by: Russell King (Oracle)
#   Link: https://patch.msgid.link/20240924022857.865422-1-jiawenwu@trustnetic.com
#   Signed-off-by: Paolo Abeni
# 
#   9a24481f885088efba8d59dfe3e016d6bf9dc18b
#    drivers/net/pcs/pcs-xpcs-wx.c | 2 +-
#    1 file changed, 1 insertion(+), 1 deletion(-)
# 
diff --git a/arch/arm/boot/dts/nxp/vf/vf610-zii-dev-rev-b.dts b/arch/arm/boot/dts/nxp/vf/vf610-zii-dev-rev-b.dts
index 029f49be40e3..3df582758e45 100644
--- a/arch/arm/boot/dts/nxp/vf/vf610-zii-dev-rev-b.dts
+++ b/arch/arm/boot/dts/nxp/vf/vf610-zii-dev-rev-b.dts
@@ -61,6 +61,12 @@ port@2 {
 						phy-handle = <&switch0phy2>;
 					};
 
+					port@4 {
+						reg = <4>;
+						label = "optical2";
+						sfp = <&opt_p2>;
+					};
+
 					switch0port5: port@5 {
 						reg = <5>;
 						label = "dsa";
@@ -221,34 +227,18 @@ port@1 {
 						phy-mode = "sgmii";
 					};
 
-					port@2 {
-						reg = <2>;
-						label = "lan8";
-						phy-handle = <&switch2phy2>;
-					};
+					/* port 2 is mis-wired */
 
 					port@3 {
 						reg = <3>;
 						label = "optical3";
-
-						fixed-link {
-							speed = <1000>;
-							full-duplex;
-							link-gpios = <&gpio6 2
-							      GPIO_ACTIVE_HIGH>;
-						};
+						sfp = <&opt_p3>;
 					};
 
 					port@4 {
 						reg = <4>;
 						label = "optical4";
-
-						fixed-link {
-							speed = <1000>;
-							full-duplex;
-							link-gpios = <&gpio6 3
-							      GPIO_ACTIVE_HIGH>;
-						};
+						sfp = <&opt_p4>;
 					};
 
 					switch2port9: port@9 {
@@ -269,12 +259,20 @@ mdio {
 					#size-cells = <0>;
 
 					switch2phy0: phy@0 {
+						interrupt-parent = <&gpio0>;
+						interrupts = <22 IRQ_TYPE_LEVEL_LOW>;
 						reg = <0>;
+						pinctrl-names = "default";
+						pinctrl-0 = <&pinctrl_mv88e1545>;
 					};
 					switch2phy1: phy@1 {
+						interrupt-parent = <&gpio0>;
+						interrupts = <22 IRQ_TYPE_LEVEL_LOW>;
 						reg = <1>;
 					};
 					switch2phy2: phy@2 {
+						interrupt-parent = <&gpio0>;
+						interrupts = <22 IRQ_TYPE_LEVEL_LOW>;
 						reg = <2>;
 					};
 				};
@@ -320,6 +318,31 @@ at93c46d@1 {
 			select-gpios = <&gpio4 4 GPIO_ACTIVE_HIGH>;
 		};
 	};
+
+	opt_p2: sff0 {
+		compatible = "sff,sff";
+		i2c-bus = <&opt_p2_i2c>;
+		los-gpios = <&gpio6 1 GPIO_ACTIVE_HIGH>;
+	};
+
+	opt_p1: sff1 {
+		compatible = "sff,sff";
+		i2c-bus = <&opt_p1_i2c>;
+		los-gpios = <&gpio6 0 GPIO_ACTIVE_HIGH>;
+		status = "disabled";
+	};
+
+	opt_p4: sff2 {
+		compatible = "sff,sff";
+		i2c-bus = <&opt_p4_i2c>;
+		los-gpios = <&gpio6 3 GPIO_ACTIVE_HIGH>;
+	};
+
+	opt_p3: sff3 {
+		compatible = "sff,sff";
+		i2c-bus = <&opt_p3_i2c>;
+		los-gpios = <&gpio6 2 GPIO_ACTIVE_HIGH>;
+	};
 };
 
 &i2c0 {
@@ -355,48 +378,28 @@ i2c-mux@70 {
 		reg = <0x70>;
 		reset-gpios = <&gpio3 23 GPIO_ACTIVE_LOW>;
 
-		i2c@0 {
+		opt_p2_i2c: i2c@0 {
 			#address-cells = <1>;
 			#size-cells = <0>;
 			reg = <0>;
-
-			sfp1: eeprom@50 {
-				compatible = "atmel,24c02";
-				reg = <0x50>;
-			};
 		};
 
-		i2c@1 {
+		opt_p1_i2c: i2c@1 {
 			#address-cells = <1>;
 			#size-cells = <0>;
 			reg = <1>;
-
-			sfp2: eeprom@50 {
-				compatible = "atmel,24c02";
-				reg = <0x50>;
-			};
 		};
 
-		i2c@2 {
+		opt_p4_i2c: i2c@2 {
 			#address-cells = <1>;
 			#size-cells = <0>;
 			reg = <2>;
-
-			sfp3: eeprom@50 {
-				compatible = "atmel,24c02";
-				reg = <0x50>;
-			};
 		};
 
-		i2c@3 {
+		opt_p3_i2c: i2c@3 {
 			#address-cells = <1>;
 			#size-cells = <0>;
 			reg = <3>;
-
-			sfp4: eeprom@50 {
-				compatible = "atmel,24c02";
-				reg = <0x50>;
-			};
 		};
 
 		i2c@4 {
@@ -437,6 +440,12 @@ VF610_PAD_PTB3__GPIO_25		0x31c2
 		>;
 	};
 
+	pinctrl_mv88e1545: pinctrl-mv88e1545 {
+		fsl,pins = <
+			VF610_PAD_PTB0__GPIO_22		0x219d
+		>;
+	};
+
 	pinctrl_pca9554_22: pinctrl-pca95540-22 {
 		fsl,pins = <
 			VF610_PAD_PTB28__GPIO_98	0x219d
